	list p=16f627
	#include <p16f627.inc>
	radix dec
; Begin
	R0L EQU 0x20
	R0H EQU 0x21
	R1L EQU 0x22
	R1H EQU 0x23
	R2L EQU 0x24
	R2H EQU 0x25
	R3L EQU 0x26
	R3H EQU 0x27
	R4L EQU 0x28
	R4H EQU 0x29
	R5L EQU 0x2A
	R5H EQU 0x2B
	ORG 0x0000
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0002
	ORG 0x0004
	RETFIE
L0002:
; 1:  'program servo motoron
; 2:  'print MGV82
; 3:  'bedoeld voor het besturen van 4 servomotoren voor wissels vanuit Motorola signalen
; 4:  'van de vier signalen die van de 145027 chip komen geeft bit 3 =1 een schakelactie aan
; 5:  'bit 1 en 2 (gedeeld door 2) is het wissel nummer
; 6:  'bit 0 geeft de richting van de wissel aan.
; 7: 
; 8: Dim teller As Byte
;       The address of 'teller' is 0x2C
	teller EQU 0x2C
; 9: Dim dummy As Byte
;       The address of 'dummy' is 0x2D
	dummy EQU 0x2D
; 10: Dim servopositie1 As Byte
;       The address of 'servopositie1' is 0x2E
	servopositie1 EQU 0x2E
; 11: Dim servopositie2 As Byte
;       The address of 'servopositie2' is 0x2F
	servopositie2 EQU 0x2F
; 12: Dim servopositie3 As Byte
;       The address of 'servopositie3' is 0x30
	servopositie3 EQU 0x30
; 13: Dim servopositie4 As Byte
;       The address of 'servopositie4' is 0x31
	servopositie4 EQU 0x31
; 14: Symbol aktie = PORTB.0
;       The address of 'aktie' is 0x6,0
; 15: Symbol richting = PORTA.2
;       The address of 'richting' is 0x5,2
; 16: Symbol laagadres = PORTA.3
;       The address of 'laagadres' is 0x5,3
; 17: Symbol hoogadres = PORTA.4
;       The address of 'hoogadres' is 0x5,4
; 18: Dim welkewissel As Byte
;       The address of 'welkewissel' is 0x32
	welkewissel EQU 0x32
; 19: Dim wisselvraag1 As Byte
;       The address of 'wisselvraag1' is 0x33
	wisselvraag1 EQU 0x33
; 20: Dim wisselvraag2 As Byte
;       The address of 'wisselvraag2' is 0x34
	wisselvraag2 EQU 0x34
; 21: Dim wisselvraag3 As Byte
;       The address of 'wisselvraag3' is 0x35
	wisselvraag3 EQU 0x35
; 22: Dim wisselvraag4 As Byte
;       The address of 'wisselvraag4' is 0x36
	wisselvraag4 EQU 0x36
; 23: Symbol servo1 = PORTB.4
;       The address of 'servo1' is 0x6,4
; 24: Symbol servo2 = PORTB.6
;       The address of 'servo2' is 0x6,6
; 25: Symbol servo3 = PORTB.5
;       The address of 'servo3' is 0x6,5
; 26: Symbol servo4 = PORTB.7
;       The address of 'servo4' is 0x6,7
; 27: Dim motor1 As Byte
;       The address of 'motor1' is 0x37
	motor1 EQU 0x37
; 28: Dim motor2 As Byte
;       The address of 'motor2' is 0x38
	motor2 EQU 0x38
; 29: Dim motor3 As Byte
;       The address of 'motor3' is 0x39
	motor3 EQU 0x39
; 30: Dim motor4 As Byte
;       The address of 'motor4' is 0x3A
	motor4 EQU 0x3A
; 31: main: 
L0001:
; 32: CMCON = 7
	MOVLW 0x07
	MOVWF 0x1F
; 33: TRISB = %00001111
	BSF STATUS,RP0
	MOVLW 0x0F
	MOVWF 0x06
; 34: TRISA = %11111111
	MOVLW 0xFF
	MOVWF 0x05
; 35: PORTB = %00001111
	BCF STATUS,RP0
	MOVLW 0x0F
	MOVWF 0x06
; 36: dummy = 0
	CLRF 0x2D
; 37: Read 0, motor1
	MOVLW 0x00
	BSF STATUS,RP0
	MOVWF EEADR
	BSF EECON1,RD
	NOP
	MOVF EEDATA,W
	BCF STATUS,RP0
	MOVWF 0x37
; 38: servopositie1 = motor1
	MOVF 0x37,W
	MOVWF 0x2E
; 39: Read 1, motor2
	MOVLW 0x01
	BSF STATUS,RP0
	MOVWF EEADR
	BSF EECON1,RD
	NOP
	MOVF EEDATA,W
	BCF STATUS,RP0
	MOVWF 0x38
; 40: servopositie2 = motor2
	MOVF 0x38,W
	MOVWF 0x2F
; 41: Read 2, motor3
	MOVLW 0x02
	BSF STATUS,RP0
	MOVWF EEADR
	BSF EECON1,RD
	NOP
	MOVF EEDATA,W
	BCF STATUS,RP0
	MOVWF 0x39
; 42: servopositie3 = motor3
	MOVF 0x39,W
	MOVWF 0x30
; 43: Read 3, motor4
	MOVLW 0x03
	BSF STATUS,RP0
	MOVWF EEADR
	BSF EECON1,RD
	NOP
	MOVF EEDATA,W
	BCF STATUS,RP0
	MOVWF 0x3A
; 44: servopositie4 = motor4
	MOVF 0x3A,W
	MOVWF 0x31
; 45: While dummy = 0
L0003:
	MOVF 0x2D,W
	SUBLW 0x00
	BTFSS STATUS,Z
	GOTO L0004
; 46: If aktie = 1 Then 'er komt een commando binnen
	BTFSS 0x06,0
	GOTO L0005
; 47: welkewissel = 0
	CLRF 0x32
; 48: If laagadres = 1 Then
	BTFSS 0x05,3
	GOTO L0006
; 49: welkewissel = 1
	MOVLW 0x01
	MOVWF 0x32
; 50: Endif
L0006:	MOVLW 0x1F
	ANDWF STATUS,F
; 51: If hoogadres = 1 Then
	BTFSS 0x05,4
	GOTO L0007
; 52: welkewissel = welkewissel + 2
	MOVF 0x32,W
	ADDLW 0x02
	MOVWF 0x32
; 53: Endif
L0007:	MOVLW 0x1F
	ANDWF STATUS,F
; 54: Select Case welkewissel
; 55: Case 0
	MOVF 0x32,W
	SUBLW 0x00
	BTFSS STATUS,Z
	GOTO L0008
; 56: If richting = 0 Then
	BTFSC 0x05,2
	GOTO L0009
; 57: motor1 = 100
	MOVLW 0x64
	MOVWF 0x37
; 58: Else
	GOTO L0010
L0009:	MOVLW 0x1F
	ANDWF STATUS,F
; 59: motor1 = 200
	MOVLW 0xC8
	MOVWF 0x37
; 60: Endif
L0010:	MOVLW 0x1F
	ANDWF STATUS,F
; 61: Case 1
	GOTO L0011
L0008:	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x32,W
	SUBLW 0x01
	BTFSS STATUS,Z
	GOTO L0012
; 62: If richting = 0 Then
	BTFSC 0x05,2
	GOTO L0013
; 63: motor2 = 100
	MOVLW 0x64
	MOVWF 0x38
; 64: Else
	GOTO L0014
L0013:	MOVLW 0x1F
	ANDWF STATUS,F
; 65: motor2 = 200
	MOVLW 0xC8
	MOVWF 0x38
; 66: Endif
L0014:	MOVLW 0x1F
	ANDWF STATUS,F
; 67: Case 2
	GOTO L0015
L0012:	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x32,W
	SUBLW 0x02
	BTFSS STATUS,Z
	GOTO L0016
; 68: If richting = 0 Then
	BTFSC 0x05,2
	GOTO L0017
; 69: motor3 = 100
	MOVLW 0x64
	MOVWF 0x39
; 70: Else
	GOTO L0018
L0017:	MOVLW 0x1F
	ANDWF STATUS,F
; 71: motor3 = 200
	MOVLW 0xC8
	MOVWF 0x39
; 72: Endif
L0018:	MOVLW 0x1F
	ANDWF STATUS,F
; 73: Case Else
	GOTO L0019
L0016:	MOVLW 0x1F
	ANDWF STATUS,F
; 74: If richting = 0 Then
	BTFSC 0x05,2
	GOTO L0020
; 75: motor4 = 100
	MOVLW 0x64
	MOVWF 0x3A
; 76: Else
	GOTO L0021
L0020:	MOVLW 0x1F
	ANDWF STATUS,F
; 77: motor4 = 200
	MOVLW 0xC8
	MOVWF 0x3A
; 78: Endif
L0021:	MOVLW 0x1F
	ANDWF STATUS,F
; 79: EndSelect
L0019:	MOVLW 0x1F
	ANDWF STATUS,F
L0015:	MOVLW 0x1F
	ANDWF STATUS,F
L0011:	MOVLW 0x1F
	ANDWF STATUS,F
; 80: Endif
L0005:	MOVLW 0x1F
	ANDWF STATUS,F
; 81: WaitMs 10
	MOVLW 0x0A
	MOVWF R0L
	CLRF R0H
	CALL W001
; 82:  'motor 1
; 83: If motor1 = 100 Then
	MOVF 0x37,W
	SUBLW 0x64
	BTFSS STATUS,Z
	GOTO L0022
; 84: If servopositie1 > 100 Then
	MOVF 0x2E,W
	SUBLW 0x64
	BTFSC STATUS,C
	GOTO L0023
; 85: servopositie1 = servopositie1 - 1
	MOVLW 0x01
	SUBWF 0x2E,W
	MOVWF 0x2E
; 86: ServoOut servo1, servopositie1
	MOVF 0x2E,W
	MOVWF R4H
	MOVF R4H,F
	BTFSC STATUS,Z
	GOTO L0025
	BSF PORTB,4
L0024:
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	DECF R4H,F
	BTFSS STATUS,Z
	GOTO L0024
	BCF PORTB,4
L0025:
; 87: If servopositie1 = 100 Then
	MOVF 0x2E,W
	SUBLW 0x64
	BTFSS STATUS,Z
	GOTO L0026
; 88: Write 0, 100
	MOVLW 0x00
	BSF STATUS,RP0
	MOVWF EEADR
	MOVLW 0x64
	MOVWF EEDATA
	BSF EECON1,WREN
	MOVLW 0x55
	MOVWF EECON2
	MOVLW 0xAA
	MOVWF EECON2
	BSF EECON1,WR
L0027:	BTFSC EECON1,WR
	GOTO L0027
	BCF EECON1,WREN
	BCF STATUS,RP0
	BCF PIR1,EEIF
; 89: Endif
L0026:	MOVLW 0x1F
	ANDWF STATUS,F
; 90: Endif
L0023:	MOVLW 0x1F
	ANDWF STATUS,F
; 91: Else
	GOTO L0028
L0022:	MOVLW 0x1F
	ANDWF STATUS,F
; 92: If servopositie1 < 200 Then
	MOVLW 0xC8
	SUBWF 0x2E,W
	BTFSC STATUS,C
	GOTO L0029
; 93: servopositie1 = servopositie1 + 1
	MOVF 0x2E,W
	ADDLW 0x01
	MOVWF 0x2E
; 94: ServoOut servo1, servopositie1
	MOVF 0x2E,W
	MOVWF R4H
	MOVF R4H,F
	BTFSC STATUS,Z
	GOTO L0031
	BSF PORTB,4
L0030:
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	DECF R4H,F
	BTFSS STATUS,Z
	GOTO L0030
	BCF PORTB,4
L0031:
; 95: If servopositie1 = 200 Then
	MOVF 0x2E,W
	SUBLW 0xC8
	BTFSS STATUS,Z
	GOTO L0032
; 96: Write 0, 200
	MOVLW 0x00
	BSF STATUS,RP0
	MOVWF EEADR
	MOVLW 0xC8
	MOVWF EEDATA
	BSF EECON1,WREN
	MOVLW 0x55
	MOVWF EECON2
	MOVLW 0xAA
	MOVWF EECON2
	BSF EECON1,WR
L0033:	BTFSC EECON1,WR
	GOTO L0033
	BCF EECON1,WREN
	BCF STATUS,RP0
	BCF PIR1,EEIF
; 97: Endif
L0032:	MOVLW 0x1F
	ANDWF STATUS,F
; 98: Endif
L0029:	MOVLW 0x1F
	ANDWF STATUS,F
; 99: Endif
L0028:	MOVLW 0x1F
	ANDWF STATUS,F
; 100:  'motor 2
; 101: If motor2 = 100 Then
	MOVF 0x38,W
	SUBLW 0x64
	BTFSS STATUS,Z
	GOTO L0034
; 102: If servopositie2 > 100 Then
	MOVF 0x2F,W
	SUBLW 0x64
	BTFSC STATUS,C
	GOTO L0035
; 103: servopositie2 = servopositie2 - 1
	MOVLW 0x01
	SUBWF 0x2F,W
	MOVWF 0x2F
; 104: ServoOut servo2, servopositie2
	MOVF 0x2F,W
	MOVWF R4H
	MOVF R4H,F
	BTFSC STATUS,Z
	GOTO L0037
	BSF PORTB,6
L0036:
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	DECF R4H,F
	BTFSS STATUS,Z
	GOTO L0036
	BCF PORTB,6
L0037:
; 105: If servopositie2 = 100 Then
	MOVF 0x2F,W
	SUBLW 0x64
	BTFSS STATUS,Z
	GOTO L0038
; 106: Write 1, 100
	MOVLW 0x01
	BSF STATUS,RP0
	MOVWF EEADR
	MOVLW 0x64
	MOVWF EEDATA
	BSF EECON1,WREN
	MOVLW 0x55
	MOVWF EECON2
	MOVLW 0xAA
	MOVWF EECON2
	BSF EECON1,WR
L0039:	BTFSC EECON1,WR
	GOTO L0039
	BCF EECON1,WREN
	BCF STATUS,RP0
	BCF PIR1,EEIF
; 107: Endif
L0038:	MOVLW 0x1F
	ANDWF STATUS,F
; 108: Endif
L0035:	MOVLW 0x1F
	ANDWF STATUS,F
; 109: Else
	GOTO L0040
L0034:	MOVLW 0x1F
	ANDWF STATUS,F
; 110: If servopositie2 < 200 Then
	MOVLW 0xC8
	SUBWF 0x2F,W
	BTFSC STATUS,C
	GOTO L0041
; 111: servopositie2 = servopositie2 + 1
	MOVF 0x2F,W
	ADDLW 0x01
	MOVWF 0x2F
; 112: ServoOut servo2, servopositie2
	MOVF 0x2F,W
	MOVWF R4H
	MOVF R4H,F
	BTFSC STATUS,Z
	GOTO L0043
	BSF PORTB,6
L0042:
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	DECF R4H,F
	BTFSS STATUS,Z
	GOTO L0042
	BCF PORTB,6
L0043:
; 113: If servopositie2 = 200 Then
	MOVF 0x2F,W
	SUBLW 0xC8
	BTFSS STATUS,Z
	GOTO L0044
; 114: Write 1, 200
	MOVLW 0x01
	BSF STATUS,RP0
	MOVWF EEADR
	MOVLW 0xC8
	MOVWF EEDATA
	BSF EECON1,WREN
	MOVLW 0x55
	MOVWF EECON2
	MOVLW 0xAA
	MOVWF EECON2
	BSF EECON1,WR
L0045:	BTFSC EECON1,WR
	GOTO L0045
	BCF EECON1,WREN
	BCF STATUS,RP0
	BCF PIR1,EEIF
; 115: Endif
L0044:	MOVLW 0x1F
	ANDWF STATUS,F
; 116: Endif
L0041:	MOVLW 0x1F
	ANDWF STATUS,F
; 117: Endif
L0040:	MOVLW 0x1F
	ANDWF STATUS,F
; 118:  'motor 3
; 119: If motor3 = 100 Then
	MOVF 0x39,W
	SUBLW 0x64
	BTFSS STATUS,Z
	GOTO L0046
; 120: If servopositie3 > 100 Then
	MOVF 0x30,W
	SUBLW 0x64
	BTFSC STATUS,C
	GOTO L0047
; 121: servopositie3 = servopositie3 - 1
	MOVLW 0x01
	SUBWF 0x30,W
	MOVWF 0x30
; 122: ServoOut servo3, servopositie3
	MOVF 0x30,W
	MOVWF R4H
	MOVF R4H,F
	BTFSC STATUS,Z
	GOTO L0049
	BSF PORTB,5
L0048:
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	DECF R4H,F
	BTFSS STATUS,Z
	GOTO L0048
	BCF PORTB,5
L0049:
; 123: If servopositie3 = 100 Then
	MOVF 0x30,W
	SUBLW 0x64
	BTFSS STATUS,Z
	GOTO L0050
; 124: Write 2, 100
	MOVLW 0x02
	BSF STATUS,RP0
	MOVWF EEADR
	MOVLW 0x64
	MOVWF EEDATA
	BSF EECON1,WREN
	MOVLW 0x55
	MOVWF EECON2
	MOVLW 0xAA
	MOVWF EECON2
	BSF EECON1,WR
L0051:	BTFSC EECON1,WR
	GOTO L0051
	BCF EECON1,WREN
	BCF STATUS,RP0
	BCF PIR1,EEIF
; 125: Endif
L0050:	MOVLW 0x1F
	ANDWF STATUS,F
; 126: Endif
L0047:	MOVLW 0x1F
	ANDWF STATUS,F
; 127: Else
	GOTO L0052
L0046:	MOVLW 0x1F
	ANDWF STATUS,F
; 128: If servopositie3 < 200 Then
	MOVLW 0xC8
	SUBWF 0x30,W
	BTFSC STATUS,C
	GOTO L0053
; 129: servopositie3 = servopositie3 + 1
	MOVF 0x30,W
	ADDLW 0x01
	MOVWF 0x30
; 130: ServoOut servo3, servopositie3
	MOVF 0x30,W
	MOVWF R4H
	MOVF R4H,F
	BTFSC STATUS,Z
	GOTO L0055
	BSF PORTB,5
L0054:
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	DECF R4H,F
	BTFSS STATUS,Z
	GOTO L0054
	BCF PORTB,5
L0055:
; 131: If servopositie3 = 200 Then
	MOVF 0x30,W
	SUBLW 0xC8
	BTFSS STATUS,Z
	GOTO L0056
; 132: Write 2, 200
	MOVLW 0x02
	BSF STATUS,RP0
	MOVWF EEADR
	MOVLW 0xC8
	MOVWF EEDATA
	BSF EECON1,WREN
	MOVLW 0x55
	MOVWF EECON2
	MOVLW 0xAA
	MOVWF EECON2
	BSF EECON1,WR
L0057:	BTFSC EECON1,WR
	GOTO L0057
	BCF EECON1,WREN
	BCF STATUS,RP0
	BCF PIR1,EEIF
; 133: Endif
L0056:	MOVLW 0x1F
	ANDWF STATUS,F
; 134: Endif
L0053:	MOVLW 0x1F
	ANDWF STATUS,F
; 135: Endif
L0052:	MOVLW 0x1F
	ANDWF STATUS,F
; 136:  'motor 4
; 137: If motor4 = 100 Then
	MOVF 0x3A,W
	SUBLW 0x64
	BTFSS STATUS,Z
	GOTO L0058
; 138: If servopositie4 > 100 Then
	MOVF 0x31,W
	SUBLW 0x64
	BTFSC STATUS,C
	GOTO L0059
; 139: servopositie4 = servopositie4 - 1
	MOVLW 0x01
	SUBWF 0x31,W
	MOVWF 0x31
; 140: ServoOut servo4, servopositie4
	MOVF 0x31,W
	MOVWF R4H
	MOVF R4H,F
	BTFSC STATUS,Z
	GOTO L0061
	BSF PORTB,7
L0060:
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	DECF R4H,F
	BTFSS STATUS,Z
	GOTO L0060
	BCF PORTB,7
L0061:
; 141: If servopositie4 = 100 Then
	MOVF 0x31,W
	SUBLW 0x64
	BTFSS STATUS,Z
	GOTO L0062
; 142: Write 3, 100
	MOVLW 0x03
	BSF STATUS,RP0
	MOVWF EEADR
	MOVLW 0x64
	MOVWF EEDATA
	BSF EECON1,WREN
	MOVLW 0x55
	MOVWF EECON2
	MOVLW 0xAA
	MOVWF EECON2
	BSF EECON1,WR
L0063:	BTFSC EECON1,WR
	GOTO L0063
	BCF EECON1,WREN
	BCF STATUS,RP0
	BCF PIR1,EEIF
; 143: Endif
L0062:	MOVLW 0x1F
	ANDWF STATUS,F
; 144: Endif
L0059:	MOVLW 0x1F
	ANDWF STATUS,F
; 145: Else
	GOTO L0064
L0058:	MOVLW 0x1F
	ANDWF STATUS,F
; 146: If servopositie4 < 200 Then
	MOVLW 0xC8
	SUBWF 0x31,W
	BTFSC STATUS,C
	GOTO L0065
; 147: servopositie4 = servopositie4 + 1
	MOVF 0x31,W
	ADDLW 0x01
	MOVWF 0x31
; 148: ServoOut servo4, servopositie4
	MOVF 0x31,W
	MOVWF R4H
	MOVF R4H,F
	BTFSC STATUS,Z
	GOTO L0067
	BSF PORTB,7
L0066:
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	DECF R4H,F
	BTFSS STATUS,Z
	GOTO L0066
	BCF PORTB,7
L0067:
; 149: If servopositie4 = 200 Then
	MOVF 0x31,W
	SUBLW 0xC8
	BTFSS STATUS,Z
	GOTO L0068
; 150: Write 3, 200
	MOVLW 0x03
	BSF STATUS,RP0
	MOVWF EEADR
	MOVLW 0xC8
	MOVWF EEDATA
	BSF EECON1,WREN
	MOVLW 0x55
	MOVWF EECON2
	MOVLW 0xAA
	MOVWF EECON2
	BSF EECON1,WR
L0069:	BTFSC EECON1,WR
	GOTO L0069
	BCF EECON1,WREN
	BCF STATUS,RP0
	BCF PIR1,EEIF
; 151: Endif
L0068:	MOVLW 0x1F
	ANDWF STATUS,F
; 152: Endif
L0065:	MOVLW 0x1F
	ANDWF STATUS,F
; 153: Endif
L0064:	MOVLW 0x1F
	ANDWF STATUS,F
; 154: 
; 155: Wend
	GOTO L0003
L0004:	MOVLW 0x1F
	ANDWF STATUS,F
; 156: End
L0070:	GOTO L0070
; End of program
L0071:	GOTO L0071
; Waitms Routine
W001:	MOVF R0L,F
	BTFSC STATUS,Z
	GOTO W002
	CALL W003
	DECF R0L,F
	NOP
	NOP
	NOP
	NOP
	NOP
	GOTO W001
W002:	MOVF R0H,F
	BTFSC STATUS,Z
	RETURN
	CALL W003
	DECF R0H,F
	DECF R0L,F
	GOTO W001
W003:	MOVLW 0x0C
	MOVWF R2H
W004:	DECFSZ R2H,F
	GOTO W004
	NOP
	NOP
	MOVLW 0x12
	MOVWF R1L
W005:	DECFSZ R1L,F
	GOTO W006
	CALL W007
	CALL W007
	NOP
	NOP
	RETURN
W006:	CALL W007
	GOTO W005
W007:	MOVLW 0x0D
	MOVWF R2L
W008:	DECFSZ R2L,F
	GOTO W008
	NOP
	RETURN
; End of listing
	END
